Subject: Re: qla3xxx: Odd likely incorrect use of test_bit in qla3xxx.c

From: Joe Perches <[email-masked]>
Date: Wed, 13 May 2015 10:34:51 -0700

On Wed, 2015-05-13 at 16:19 +0300, Dan Carpenter wrote:
> Good eye, Joe.
> 
> I wrote a Smatch check to find similar bugs.  Te rhey weren't any other
> places which tried to do bitwise OR.  The bug that happens occasionally
> is:
> 
> #define MY_FLAG BIT(1)
> 
> 	if (test_bit(MY_FLAG, &map)) {
> 		...
> 
> It's not normally harmful if it's used consistently, but ath9k had
> memory corruption because they do:
> 
> 	set_bit(BIT(6), &some_unsigned_long);
> 
> Anyway, I'll send patches for the bugs I found and push the Smatch
> check. Thanks!

In case the patches you found weren't of this type,
there are other possibly suspicious uses with & like:

drivers/usb/host/ehci-tegra.c:		set_bit((wIndex & 0xff) - 1, &ehci->suspended_ports);